#!/usr/bin/python
#-*- coding: utf-8 -*-

import obj
import re
from mimetypes import guess_type

class MARKERS:
    STOPS = ('.', '?', '!')
    PHRASERS = (',', ':', ';', '"', "'")

def prepare(text):
    text = re.sub('"|\'|\"|\(|\)|\[|\]|,|;|:', '', text)
    text = re.sub('[a-zA-Z](\.|!|\?)', '', text)
    return text

def tokenize(text, wordize = True, gramize = True):
    if type(text) != str:
        raise TypeError('"text" argument must be a str, not %s.' %(type(text)))
    if guess_type(text) != (None, None):
        raise obj.Errors.CorruptedFile('"text" argument is corrupted or not a string.')
    
    if wordize == True:
        cents = re.split('\. |\.\.\. |\? |! |\n+|[a-zA-Z]\.', text)
        
        tokens = []
        
        for i in cents:
            tokens.append(tuple(re.split(', |; |: | |" |"', i.lower())))
        
        del cents
        
        if gramize == True:
            return tokens
        else:
            nongrams = []
            for i in tokens:
                for q in i:
                    nongrams.append(q)
            return nongrams
    else:
        tokens = []
        x = []
        parsed = list(text)
        for i in parsed:
            if i in MARKERS.STOPS or i in MARKERS.PHRASERS or i == ' ':
                tokens.append(tuple(x))
                x = []
            else:
                x.append(i.lower())
        del x
        del parsed
        
        if gramize == True:
            return tokens
        else:
            nongrams = []
            for i in tokens:
                for q in i:
                    nongrams.append(q)